import { useEffect, useState } from "react";
import Dimensions from "../Dimensions/index";
function useWindowDimensions() {
  const [dims, setDims] = useState(() => Dimensions.get("window"));
  return useEffect(() => {
    function handleChange({ window }) {
      window != null && setDims(window);
    }
    return Dimensions.addEventListener("change", handleChange), setDims(Dimensions.get("window")), () => {
      Dimensions.removeEventListener("change", handleChange);
    };
  }, []), dims;
}
export {
  useWindowDimensions as default
};
//# sourceMappingURL=index.js.map
